#include <pam.h>
#include <stdint.h>
#include <inttypes.h>
#include <assert.h>
#include <string.h>

#define eassert assert

typedef struct {
  unsigned long rgb; /* on screen */
  char c; /* canonical */
} CanonColourInfo;

static const CanonColourInfo canoncolourinfos[]= {
  { 0x475A5E, '*' }, /* edge */
  { 0x7D9094, '+' }, /* interbox */
  { 0xBDC5BF, ' ' }, /* background - pale */
  { 0xADB5AF, ' ' }, /* background - dark */
  { 0x000000, 'o' }, /* foreground */
  { 0xD4B356, ' ' }, /* background (cursor) */
  { 0xFFFFFF, 'o' }, /* foreground (cursor) */
  { 0,0 }
};

static int height, width;
static char *image;

static void load_image_and_canonify(void) {
  struct pam inpam;
  unsigned char rgb[3];
  int x,y,r;
  const CanonColourInfo *cci;

  pnm_readpaminit(stdin, &inpam, sizeof(inpam));
  height= inpam.height;
  width= inpam.width;
  eassert(inpam.maxval == 255);
  eassert(inpam.bytes_per_sample == 1);

  image= malloc(width*height);
  eassert(image);
  memset(image,'?',width*height);

  for (y=0; y<height; y++) {
    for (x=0; x<width; x++) {
      r= fread(&rgb,1,3,stdin);  eassert(r==3);
      unsigned long rgb_l=
	((unsigned long)rgb[0]<<16) |
	((unsigned long)rgb[1]<<8) |
	               (rgb[2]);
      for (cci=canoncolourinfos; cci->c; cci++)
	if (cci->rgb == rgb_l) {
	  image[y*width + x]= cci->c;
	  break;
	}
      if (y==234 && x==82) {
	printf("y=%d/%d x=%d/%d rgb=%d,%d,%d rgb_l=%lx c=%c\n",
	       y,height,x,width, rgb[0],rgb[1],rgb[2], rgb_l, image[y*width+x]);
      }
    }
    r= fwrite(image + y*width, 1,width, stdout);  eassert(r==width);
    putchar('\n');
  }
  eassert(!fflush(stdout));
  eassert(!ferror(stdout));
}
 
int main(void) {
  load_image_and_canonify();
  /*
  find_main_rectangle();
  repeatedly_find_top_thing();
  */
  return 0;
}
